'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = C2SchemaAntdForm;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Fetch = require('./Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

var _compatible = require('@ant-design/compatible');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _C2Form = require('./C2Form');

var _C2Form2 = _interopRequireDefault(_C2Form);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function C2SchemaAntdForm(props) {
    var schemaData = function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(data) {
            var _this = this;

            var formData1, item, formAttributes, _loop, i;

            return regeneratorRuntime.wrap(function _callee$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            formData1 = {};
                            item = [];
                            formAttributes = {};
                            _loop = /*#__PURE__*/regeneratorRuntime.mark(function _loop(i) {
                                var _loop2, j, _loop3, index;

                                return regeneratorRuntime.wrap(function _loop$(_context2) {
                                    while (1) {
                                        switch (_context2.prev = _context2.next) {
                                            case 0:
                                                if (!(i === 'formConf')) {
                                                    _context2.next = 10;
                                                    break;
                                                }

                                                formAttributes.labelAlign = data[i].labelPosition;
                                                formAttributes.size = data[i].size;
                                                formAttributes.gutter = data[i].gutter;
                                                formData1.labelSpan = data[i].labelCol;
                                                formData1.wrapperSpan = data[i].wrapperCol;
                                                setformAttributes(formAttributes);
                                                setFormData(formData1);
                                                _context2.next = 20;
                                                break;

                                            case 10:
                                                if (!(i === 'properties')) {
                                                    _context2.next = 20;
                                                    break;
                                                }

                                                _loop2 = /*#__PURE__*/regeneratorRuntime.mark(function _loop2(j) {
                                                    var itemtow, config, urlData;
                                                    return regeneratorRuntime.wrap(function _loop2$(_context) {
                                                        while (1) {
                                                            switch (_context.prev = _context.next) {
                                                                case 0:
                                                                    itemtow = {};
                                                                    config = void 0;

                                                                    itemtow.attribute = data[i][j];
                                                                    itemtow.label = data[i][j].label;
                                                                    itemtow.name = j;
                                                                    itemtow.attribute.prefix = suffix(data[i][j]['prefix-icon']);
                                                                    itemtow.attribute.suffix = suffix(data[i][j]['suffix-icon']);
                                                                    itemtow.attribute.addonBefore = data[i][j].prepend;
                                                                    itemtow.attribute.addonAfter = data[i][j].append;
                                                                    itemtow.attribute.allowClear = data[i][j].clearable;
                                                                    itemtow.attribute.autoSize = data[i][j].autosize;
                                                                    itemtow.labelSpan = data[i][j].labelCol;
                                                                    itemtow.wrapperSpan = data[i][j].wrapperCol;
                                                                    itemtow.attribute.checkedChildren = data[i][j]['active-text'];
                                                                    itemtow.attribute.unCheckedChildren = data[i][j]['inactive-text'];
                                                                    itemtow.attribute.allowHalf = data[i][j]['allow-half'];
                                                                    itemtow.attribute.count = data[i][j].max;
                                                                    if (data[i][j].multiple) {
                                                                        itemtow.attribute.mode = 'multiple';
                                                                    }
                                                                    if (data[i][j].filterable) {
                                                                        itemtow.attribute.showSearch = true;
                                                                    }
                                                                    if (data[i][j].nameKey === 'date') {
                                                                        itemtow.type = 'datePicker';
                                                                        itemtow.attribute.defaultValue = data[i][j].defaultValue ? (0, _moment2.default)(data[i][j].defaultValue, data[i][j].format) : null;
                                                                        config = { rules: data[i][j].regList ? [].concat(_toConsumableArray(data[i][j].regList)) : [] };
                                                                        config.rules.push({ required: data[i][j].required, message: '必填项!' });
                                                                    } else if (data[i][j].nameKey === 'daterange') {
                                                                        itemtow.type = 'rangePicker';
                                                                        itemtow.attribute.defaultValue = data[i][j].defaultValue ? [(0, _moment2.default)(data[i][j].defaultValue[0], data[i][j].format), (0, _moment2.default)(data[i][j].defaultValue[1], data[i][j].format)] : null;
                                                                        itemtow.attribute.showTime = true;
                                                                        config = { rules: data[i][j].regList ? [].concat(_toConsumableArray(data[i][j].regList)) : [] };
                                                                        config.rules.push({ required: data[i][j].required, message: '必填项!' });
                                                                    } else if (data[i][j].nameKey === 'time-picker') {
                                                                        itemtow.type = 'timePicker';
                                                                        itemtow.attribute.defaultValue = data[i][j].defaultValue ? (0, _moment2.default)(data[i][j].defaultValue, data[i][j].format) : null;
                                                                        config = { rules: data[i][j].regList ? [].concat(_toConsumableArray(data[i][j].regList)) : [] };
                                                                        config.rules.push({ required: data[i][j].required, message: '必填项!' });
                                                                    } else if (data[i][j].nameKey === 'time-picker-range') {
                                                                        itemtow.type = 'timeRangePicker';
                                                                        itemtow.attribute.defaultValue = data[i][j].defaultValue ? [(0, _moment2.default)(data[i][j].defaultValue[0], data[i][j].format), (0, _moment2.default)(data[i][j].defaultValue[1], data[i][j].format)] : null;
                                                                        config = { rules: data[i][j].regList ? [].concat(_toConsumableArray(data[i][j].regList)) : [] };
                                                                        config.rules.push({ required: data[i][j].required, message: '必填项!' });
                                                                    } else if (data[i][j].nameKey === 'input') {} else {
                                                                        if (data[i][j].nameKey === 'radio') {
                                                                            itemtow.type = 'radioGroup';
                                                                        } else if (data[i][j].nameKey === 'checkbox') {
                                                                            itemtow.type = 'checkboxGroup';
                                                                        } else {
                                                                            itemtow.type = data[i][j].nameKey;
                                                                        }
                                                                        itemtow.showValue = data[i][j].defaultValue;
                                                                        config = { initialValue: data[i][j].defaultValue, rules: data[i][j].regList ? [].concat(_toConsumableArray(data[i][j].regList)) : [] };
                                                                        config.rules.push({ required: data[i][j].required, message: '必填项!' });
                                                                    }
                                                                    itemtow.fieldDecoratorOptions = config;
                                                                    itemtow.span = data[i][j].span;

                                                                    if (!data[i][j].options) {
                                                                        _context.next = 42;
                                                                        break;
                                                                    }

                                                                    if (!(data[i][j].dataType === 'dynamic')) {
                                                                        _context.next = 41;
                                                                        break;
                                                                    }

                                                                    if (!data[i][j].fetchUrl) {
                                                                        _context.next = 38;
                                                                        break;
                                                                    }

                                                                    _context.prev = 25;
                                                                    _context.next = 28;
                                                                    return _Fetch2.default.get(data[i][j].fetchUrl);

                                                                case 28:
                                                                    urlData = _context.sent;

                                                                    if (urlData && urlData instanceof Array) {
                                                                        itemtow.attribute.options = urlData.map(function (index) {
                                                                            var test = {};
                                                                            test.label = index[data[i][j].labelKey];
                                                                            test.value = index[data[i][j].valueKey];
                                                                            return test;
                                                                        });
                                                                    } else {
                                                                        itemtow.attribute.options = [];
                                                                    }
                                                                    _context.next = 36;
                                                                    break;

                                                                case 32:
                                                                    _context.prev = 32;
                                                                    _context.t0 = _context['catch'](25);

                                                                    _antd.message.error('接口获取失败报 获取' + data[i][j].label + '数据源失败');
                                                                    itemtow.attribute.options = [];

                                                                case 36:
                                                                    _context.next = 39;
                                                                    break;

                                                                case 38:
                                                                    _antd.message.error('没有fetchUrl报请填写远程地址！');

                                                                case 39:
                                                                    _context.next = 42;
                                                                    break;

                                                                case 41:
                                                                    itemtow.attribute.options = data[i][j].options ? data[i][j].options : '';

                                                                case 42:
                                                                    item.push(itemtow);

                                                                case 43:
                                                                case 'end':
                                                                    return _context.stop();
                                                            }
                                                        }
                                                    }, _loop2, _this, [[25, 32]]);
                                                });
                                                _context2.t0 = regeneratorRuntime.keys(data[i]);

                                            case 13:
                                                if ((_context2.t1 = _context2.t0()).done) {
                                                    _context2.next = 18;
                                                    break;
                                                }

                                                j = _context2.t1.value;
                                                return _context2.delegateYield(_loop2(j), 't2', 16);

                                            case 16:
                                                _context2.next = 13;
                                                break;

                                            case 18:
                                                if (props.permissions) {
                                                    _loop3 = function _loop3(index) {
                                                        if (!props.permissions[index].visble) {
                                                            item.forEach(function (test, index2) {
                                                                if (test.name === index) {
                                                                    item.splice(index2, 1);
                                                                }
                                                            });
                                                        }
                                                        if (!props.permissions[index].editable) {
                                                            item.forEach(function (test) {
                                                                if (test.name === index) {
                                                                    test.attribute.disabled = !props.permissions[index].editable;
                                                                }
                                                            });
                                                        }
                                                    };

                                                    for (index in props.permissions) {
                                                        _loop3(index);
                                                    }
                                                }
                                                setItems(item);

                                            case 20:
                                            case 'end':
                                                return _context2.stop();
                                        }
                                    }
                                }, _loop, _this);
                            });
                            _context3.t0 = regeneratorRuntime.keys(data);

                        case 5:
                            if ((_context3.t1 = _context3.t0()).done) {
                                _context3.next = 10;
                                break;
                            }

                            i = _context3.t1.value;
                            return _context3.delegateYield(_loop(i), 't2', 8);

                        case 8:
                            _context3.next = 5;
                            break;

                        case 10:
                        case 'end':
                            return _context3.stop();
                    }
                }
            }, _callee, this);
        }));

        return function schemaData(_x) {
            return _ref.apply(this, arguments);
        };
    }();

    // return (
    // <DynamicFormEditor
    //   labelSpan={formData.labelSpan}
    //   wrapperSpan={formData.wrapperSpan}
    //   alignType={'wrapper'}
    //   items={item}
    // />)

    var _useState = (0, _react.useState)({}),
        _useState2 = _slicedToArray(_useState, 2),
        formData = _useState2[0],
        setFormData = _useState2[1];

    var _useState3 = (0, _react.useState)([]),
        _useState4 = _slicedToArray(_useState3, 2),
        items = _useState4[0],
        setItems = _useState4[1];

    var _useState5 = (0, _react.useState)({}),
        _useState6 = _slicedToArray(_useState5, 2),
        data = _useState6[0],
        setData = _useState6[1];

    var _useState7 = (0, _react.useState)({}),
        _useState8 = _slicedToArray(_useState7, 2),
        formAttributes = _useState8[0],
        setformAttributes = _useState8[1];

    (0, _react.useEffect)(function () {
        if (props.schema) {
            schemaData(props.schema);
            setData(props.schema);
        } else {
            var href = window.location.href.split('?');
            if (href && href.length > 0) {
                var href2 = href[1].split('&');
                var code = href2[0].split('=');
                var isPreview = href2[1] ? href2[1].split('=') : null;
                if (isPreview !== null && isPreview[1] && isPreview[1] !== 'null' && isPreview[1] !== 'undefined') {
                    // 预览渲染表单，是否预览参数名为isPreview
                    var PREVIEW_SCHEMA = localStorage.getItem('PREVIEW_SCHEMA');
                    var _data = PREVIEW_SCHEMA ? JSON.parse(PREVIEW_SCHEMA) : null;
                    var schema = JSON.parse(_data.formSchema || '{}');
                    schemaData(schema);
                    setData(schema);
                } else {
                    // 请求接口拿，传过来的参数叫code    
                    _Fetch2.default.get('dfc/v1/forms/' + code[1]).then(function (data) {
                        if (data) {
                            var _schema = JSON.parse(data.formSchema || '{}');
                            schemaData(_schema);
                            setData(_schema);
                        }
                    });
                }
            }
        }
    }, []);
    function suffix(value) {
        return _react2.default.createElement(_compatible.Icon, { type: value });
    }
    return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
            'h1',
            null,
            data.title
        ),
        _react2.default.createElement(_C2Form2.default, {
            gutter: formAttributes.gutter,
            footer: null,
            data: props.data,
            labelSpan: formData.labelSpan,
            wrapperSpan: formData.wrapperSpan,
            alignType: 'wrapper',
            getForm: function getForm(form) {
                if (typeof props.getForm === 'function') props.getForm(form);
            },
            items: items,
            formAttributes: formAttributes
        })
    );
}