'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Field = exports.ChartCard = exports.MiniArea = exports.MiniBar = exports.default = undefined;

var _ChartCard = require('./ChartCard');

var _ChartCard2 = _interopRequireDefault(_ChartCard);

var _Field = require('./Field');

var _Field2 = _interopRequireDefault(_Field);

var _MiniArea = require('./MiniArea');

var _MiniArea2 = _interopRequireDefault(_MiniArea);

var _MiniBar = require('./MiniBar');

var _MiniBar2 = _interopRequireDefault(_MiniBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// const yuan = val => `¥ ${numeral(val).format('0,0')}`;

var Charts = {

  MiniBar: _MiniBar2.default,
  MiniArea: _MiniArea2.default,
  ChartCard: _ChartCard2.default,
  Field: _Field2.default

};

exports.default = Charts;
exports.MiniBar = _MiniBar2.default;
exports.MiniArea = _MiniArea2.default;
exports.ChartCard = _ChartCard2.default;
exports.Field = _Field2.default;