'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _templateObject = _taggedTemplateLiteral(['\n  .ant-legacy-form-item {\n    display: flex;\n  }\n  .ant-legacy-form-item-label {\n    flex: 1;\n  }\n'], ['\n  .ant-legacy-form-item {\n    display: flex;\n  }\n  .ant-legacy-form-item-label {\n    flex: 1;\n  }\n']);

exports.default = C2Form;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('@ant-design/compatible/assets/index.css');

var _antd = require('antd');

var _C2FormItem = require('./C2FormItem');

var _C2FormItem2 = _interopRequireDefault(_C2FormItem);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
// import { Form } from '@ant-design/compatible';


var FlextForm = (0, _styledComponents2.default)(_antd.Form)(_templateObject);

var FormItem = FlextForm.Item;

/**
 *动态表单编辑弹窗
 *
 * data属性：
 * label,name,attribute,required,requiredMessage,regExp,regExpMessage,fieldDecoratorOptions
 *
 */
function C2Form(props) {

    // useEffect(()=>{
    //     debugger
    //     if(props.data){
    //         setData(props.data);
    //         form.setFieldsValue(props.data);
    //     }
    // },[props.data])


    var handleSubmit = function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            var values;
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.next = 2;
                            return form.validateFields();

                        case 2:
                            values = _context.sent;

                            if (typeof props.onSubmit === 'function') {
                                props.onSubmit(null, values);
                            }

                        case 4:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this);
        }));

        return function handleSubmit() {
            return _ref.apply(this, arguments);
        };
    }();

    var _Form$useForm = _antd.Form.useForm(),
        _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
        form = _Form$useForm2[0];

    var _useState = (0, _react.useState)([]),
        _useState2 = _slicedToArray(_useState, 2),
        formItems = _useState2[0],
        setFormItems = _useState2[1];

    var _useState3 = (0, _react.useState)(props.data),
        _useState4 = _slicedToArray(_useState3, 2),
        data = _useState4[0],
        setData = _useState4[1];

    (0, _react.useEffect)(function () {
        if (typeof props.getForm === 'function') props.getForm(form);
    }, []);

    (0, _react.useEffect)(function () {
        if (props.items && props.items instanceof Array) {
            setFormItems(props.items);
        } else if (props.items && props.items instanceof Object) {
            var newitems = [].concat(_toConsumableArray(formItems));
            newitems.push(props.items);
            setFormItems(newitems);
        }

        if (props.data) {
            setData(props.data);
            form.setFieldsValue(props.data);
        }
    }, [props.items, props.data]);

    var formLayout = {
        labelCol: { span: props.labelSpan },
        wrapperCol: { span: props.wrapperSpan }
    };
    var tailFormItemLayout = {
        wrapperCol: {
            xs: {
                span: 24,
                offset: 0
            },
            sm: {
                span: 16,
                offset: 8
            }
        }
    };

    var buttonItem = function buttonItem() {
        if (props.footer === null) return '';else if (props.footer === 'default') {
            return _react2.default.createElement(
                FormItem,
                tailFormItemLayout,
                _react2.default.createElement(
                    _antd.Button,
                    { type: 'primary', onClick: handleSubmit },
                    props.submitText
                )
            );
        } else if (_typeof(props.footer) === 'object') {
            return _react2.default.createElement(
                FormItem,
                tailFormItemLayout,
                props.footer
            );
        }
    };
    console.log(form.getFieldsValue());
    return _react2.default.createElement(
        _antd.Form,
        _extends({ initialValues: data, form: form }, formLayout, props.formAttributes),
        _react2.default.createElement(
            _antd.Row,
            { gutter: props.gutter },
            formItems.map(function (item, index) {
                if (props.cols) {
                    var span = 24 / props.cols;
                    return _react2.default.isValidElement(item) ? item : _react2.default.createElement(
                        _antd.Col,
                        { span: item.span ? item.span : span },
                        _react2.default.createElement(_C2FormItem2.default, { alignType: props.alignType, item: item, key: index,
                            labelSpan: item.labelSpan ? item.labelSpan : props.labelSpan, wrapperSpan: item.wrapperSpan ? item.wrapperSpan : props.wrapperSpan,
                            dynamicform: form, data: props.data })
                    );
                } else {
                    return _react2.default.isValidElement(item) ? item : _react2.default.createElement(
                        _antd.Col,
                        { span: item.span ? item.span : 24 },
                        _react2.default.createElement(_C2FormItem2.default, { alignType: props.alignType, item: item, key: index,
                            labelSpan: item.labelSpan ? item.labelSpan : props.labelSpan, wrapperSpan: item.wrapperSpan ? item.wrapperSpan : props.wrapperSpan,
                            dynamicform: form, data: props.data })
                    );
                }
            })
        ),
        buttonItem()
    );
}

C2Form.propTypes = {
    items: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]), //表单元素定义
    data: _propTypes2.default.object, //数据
    formAttributes: _propTypes2.default.object,
    alignType: _propTypes2.default.string, //对齐方式
    getForm: _propTypes2.default.func, //antd form对象
    onChange: _propTypes2.default.func, //表单值改变事件
    onSubmit: _propTypes2.default.func, //默认的提交按钮事件
    submitText: _propTypes2.default.string, //提交按钮文本
    footer: _propTypes2.default.node, //自定义底部提交按钮
    labelSpan: _propTypes2.default.number,
    wrapperSpan: _propTypes2.default.number
};

C2Form.defaultProps = {
    submitText: '提交',
    labelSpan: 8,
    wrapperSpan: 16,
    footer: 'default',
    formAttributes: {
        layout: 'horizontal'
    },
    alignType: 'wrapper'
};

// export default Form.create({
//     //表单值变化事件，回调到
//     onValuesChange: (props, changedValues, allValues) => {
//         if (typeof props.onChange === 'function') {
//             if (props.data) {//暂只考虑编辑情况判断
//                 let changed = false;
//                 for (let key in changedValues) {
//                     if (changedValues[key] !== props.data[key]) {
//                         changed = true;
//                         break;
//                     }
//                 }
//                 props.onChange(props, changedValues, allValues, changed);
//             } else {
//                 props.onChange(props, changedValues, allValues, true);
//             }
//         }
//     }
// })(C2Form);