'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = C2Select;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _Fetch = require('./Fetch');

var _Fetch2 = _interopRequireDefault(_Fetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

fetch = _isomorphicFetch2.default;

function C2Select(props) {
    var _useState = useState([]),
        _useState2 = _slicedToArray(_useState, 2),
        options = _useState2[0],
        setOptions = _useState2[1];

    (0, _react.useEffect)(function () {
        setOptions(props.options);
    }, [props.options]);

    (0, _react.useEffect)(function () {

        if (props.fetchUrl && props.fetchUrl !== '') {
            _Fetch2.default.get(props.fetchUrl).then(function (data) {
                if (data && data instanceof Array) {
                    setOptions(data);
                } else {
                    setOptions([]);
                }
            }).catch(function (err) {
                setOptions([]);
            });
        }
    }, [props.fetchUrl]);

    return _react2.default.createElement(
        _antd.Select,
        props.attribute,
        options && options.map(function (o, i) {
            return _react2.default.createElement(
                Option,
                { key: i, value: o.value, disabled: !!o.disabled },
                o.label
            );
        })
    );
}