'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _compatible = require('@ant-design/compatible');

require('@ant-design/compatible/assets/index.css');

var _EditableTableContext = require('./EditableTableContext');

var _EditableTableContext2 = _interopRequireDefault(_EditableTableContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var EditableRow = function EditableRow(_ref) {
  var form = _ref.form,
      index = _ref.index,
      props = _objectWithoutProperties(_ref, ['form', 'index']);

  return _react2.default.createElement(
    _EditableTableContext2.default.Provider,
    { value: form },
    _react2.default.createElement('tr', props)
  );
};

exports.default = _compatible.Form.create()(EditableRow);