'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n.ant-row .ant-legacy-form-item {\n  margin-bottom:-5px !important\n}\n'], ['\n.ant-row .ant-legacy-form-item {\n  margin-bottom:-5px !important\n}\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _compatible = require('@ant-design/compatible');

require('@ant-design/compatible/assets/index.css');

var _antd = require('antd');

var _DynamicFormEditorItem = require('./DynamicFormEditorItem');

var _DynamicFormEditorItem2 = _interopRequireDefault(_DynamicFormEditorItem);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var EditorForm = (0, _styledComponents2.default)(_compatible.Form)(_templateObject);

var EditorDynamicForm = function (_PureComponent) {
  _inherits(EditorDynamicForm, _PureComponent);

  function EditorDynamicForm(props) {
    _classCallCheck(this, EditorDynamicForm);

    var _this = _possibleConstructorReturn(this, (EditorDynamicForm.__proto__ || Object.getPrototypeOf(EditorDynamicForm)).call(this, props));

    _this.state = {
      items: [],
      data: {},
      colNum: null
    };

    if (typeof props.getForm === 'function') props.getForm(props.form);
    _this.onSubmit = _this.onSubmit.bind(_this);
    _this.onCancel = _this.onCancel.bind(_this);
    return _this;
  }

  _createClass(EditorDynamicForm, [{
    key: 'onSubmit',
    value: function onSubmit(value) {
      if (typeof this.props.onSubmit === 'function') this.props.onSubmit(value);
    }
  }, {
    key: 'onCancel',
    value: function onCancel() {
      if (typeof this.props.onCancel === 'function') this.props.onCancel();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        EditorForm,
        null,
        _react2.default.createElement(
          _antd.Row,
          { gutter: 24 },
          this.state.items.map(function (item, i) {
            return _react2.default.createElement(
              _antd.Col,
              { span: item.span ? item.span : _this2.state.defaultColSpan, key: i },
              _react2.default.createElement(_DynamicFormEditorItem2.default, { onSubmit: _this2.onSubmit, onCancel: _this2.onCancel,
                item: item, key: i, dynamicform: _this2.props.form })
            );
          })
        )
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, preStatus) {
      if (nextProps.items !== preStatus.items || nextProps.colNum !== preStatus.colNum || nextProps.data !== preStatus.data) {
        var defaultColSpan = 24 / nextProps.colNum; //itemSpan
        if (nextProps.data) {
          nextProps.items.forEach(function (f) {
            if (f.name) {
              f.initialValue = nextProps.data[f.name];
            }
          });
        }
        return { items: nextProps.items, data: nextProps.data, colNum: nextProps.colNum, defaultColSpan: defaultColSpan };
      }
      return null;
    }
  }]);

  return EditorDynamicForm;
}(_react.PureComponent);

EditorDynamicForm.propTypes = {
  items: _propTypes2.default.array,
  data: _propTypes2.default.object, //默认值
  getForm: _propTypes2.default.func, //antd form对象
  colNum: _propTypes2.default.number,
  onSubmit: _propTypes2.default.func,
  onCancel: _propTypes2.default.func //清空事件
};

EditorDynamicForm.defaultProps = {
  colNum: 4
};

exports.default = _compatible.Form.create()(EditorDynamicForm);