'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  .ant-legacy-form-item {\n    display: flex;\n  }\n  .ant-legacy-form-item-label {\n    flex: 1;\n  }\n'], ['\n  .ant-legacy-form-item {\n    display: flex;\n  }\n  .ant-legacy-form-item-label {\n    flex: 1;\n  }\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _compatible = require('@ant-design/compatible');

require('@ant-design/compatible/assets/index.css');

var _antd = require('antd');

var _DynamicFormItem = require('./DynamicFormItem');

var _DynamicFormItem2 = _interopRequireDefault(_DynamicFormItem);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var FlextForm = (0, _styledComponents2.default)(_compatible.Form)(_templateObject);

var SearchForm = function (_PureComponent) {
  _inherits(SearchForm, _PureComponent);

  function SearchForm(props) {
    _classCallCheck(this, SearchForm);

    var _this = _possibleConstructorReturn(this, (SearchForm.__proto__ || Object.getPrototypeOf(SearchForm)).call(this, props));

    _this.showItemNum = props.initRow === 0 ? props.items.length : props.colNum === 1 ? props.initRow : props.colNum * props.initRow - 1;
    _this.state = {
      expand: props.initRow === 0,
      items: props.items,
      data: props.data,
      colNum: props.colNum,
      initRow: props.initRow,
      defaultColSpan: 24 / props.colNum,
      showItemNum: _this.showItemNum,
      buttonOffset: props.buttonSpan ? 0 : _this.showItemNum / props.colNum === 0 ? 24 - 24 / props.colNum : 24 - _this.showItemNum % props.colNum * 24 / props.colNum - 24 / props.colNum
    };

    if (typeof props.getForm === 'function') props.getForm(props.form);
    _this.setExpand = _this.setExpand.bind(_this);
    _this.onSearch = _this.onSearch.bind(_this);
    _this.onReset = _this.onReset.bind(_this);
    return _this;
  }

  _createClass(SearchForm, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.data) {
        this.props.form.setFieldsValue(this.props.data);
      }
    }
  }, {
    key: 'setExpand',
    value: function setExpand(value) {
      var showItemNum = value ? this.state.items.length : this.state.colNum === 1 ? this.state.initRow : this.state.colNum * this.state.initRow - 1;
      var buttonOffset = this.props.buttonSpan ? 0 : showItemNum / this.state.colNum === 0 ? 24 - this.state.defaultColSpan : 24 - showItemNum % this.state.colNum * this.state.defaultColSpan - this.state.defaultColSpan;
      this.setState({ expand: value, showItemNum: showItemNum, buttonOffset: buttonOffset });
    }
  }, {
    key: 'onSearch',
    value: function onSearch(e) {
      var _this2 = this;

      e.preventDefault();
      this.props.form.validateFields(function (err, values) {
        if (typeof _this2.props.onSearch === 'function') _this2.props.onSearch(err, values);
      });
    }
  }, {
    key: 'onReset',
    value: function onReset() {
      this.props.form.resetFields();
      if (typeof this.props.onReset === 'function') this.props.onReset();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var buttonItem = function buttonItem() {
        if (_this3.props.button === null) return '';
        if (_this3.props.button === 'default') {
          return [_react2.default.createElement(
            _antd.Button,
            { type: 'primary', htmlType: 'submit' },
            '\u67E5\u8BE2'
          ), _react2.default.createElement(
            _antd.Button,
            { style: { marginLeft: 8 }, onClick: _this3.onReset },
            '\u91CD\u7F6E'
          )];
        } else if (_typeof(_this3.props.button) === 'object') {
          return _this3.props.button;
        }
      };

      return _react2.default.createElement(
        FlextForm,
        _extends({}, this.props.formAttributes, { onSubmit: this.onSearch }),
        _react2.default.createElement(
          _antd.Row,
          { gutter: 24 },
          this.state.items.map(function (item, i) {
            return _react2.default.createElement(
              _antd.Col,
              { span: item.span ? item.span : _this3.state.defaultColSpan, key: i, style: { display: !_this3.state.expand && i >= _this3.state.showItemNum ? 'none' : 'block' } },
              _react2.default.createElement(_DynamicFormItem2.default, { labelSpan: item.labelSpan ? item.labelSpan : _this3.props.labelSpan, wrapperSpan: item.wrapperSpan ? item.wrapperSpan : _this3.props.wrapperSpan, alignType: _this3.props.alignType, item: item, key: i, dynamicform: _this3.props.form })
            );
          }),
          this.props.button === null ? '' : _react2.default.createElement(
            _antd.Col,
            { span: this.props.buttonSpan ? this.props.buttonSpan : this.state.defaultColSpan, offset: this.props.buttonOffset !== undefined ? this.props.buttonOffset : this.state.buttonOffset, style: { textAlign: 'right', marginBottom: 24 } },
            buttonItem(),
            this.state.initRow !== 0 && _react2.default.createElement(
              'a',
              { style: { marginLeft: 8, fontSize: 12 }, onClick: function onClick(e) {
                  return _this3.setExpand(!_this3.state.expand);
                } },
              '\u66F4\u591A ',
              _react2.default.createElement(_compatible.Icon, { type: this.state.expand ? 'up' : 'down' })
            )
          )
        )
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, preStatus) {
      if (nextProps.initRow !== preStatus.initRow || nextProps.colNum !== preStatus.colNum) {
        var expand = nextProps.initRow === 0;
        var defaultColSpan = 24 / nextProps.colNum;
        var showItemNum = expand ? nextProps.items.length : nextProps.colNum === 1 ? nextProps.initRow : nextProps.colNum * nextProps.initRow - 1; //显示的元素个数
        var buttonOffset = nextProps.buttonSpan ? 0 : showItemNum / nextProps.colNum === 0 ? 24 - defaultColSpan : 24 - showItemNum % nextProps.colNum * defaultColSpan - defaultColSpan;
        return { initRow: nextProps.initRow, expand: expand, colNum: nextProps.colNum, defaultColSpan: defaultColSpan, showItemNum: showItemNum, buttonOffset: buttonOffset };
      }
      if (nextProps.items !== preStatus.items) {
        return { items: nextProps.items };
      }
      return null;
    }
  }]);

  return SearchForm;
}(_react.PureComponent);

SearchForm.propTypes = {
  items: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),
  data: _propTypes2.default.object, //默认值
  alignType: _propTypes2.default.string, //对齐方式
  getForm: _propTypes2.default.func, //antd form对象
  colNum: _propTypes2.default.number,
  initRow: _propTypes2.default.number,
  onSearch: _propTypes2.default.func,
  onReset: _propTypes2.default.func, //清空事件
  button: _propTypes2.default.node, //按钮组
  buttonSpan: _propTypes2.default.number,
  buttonOffset: _propTypes2.default.number,
  onChange: _propTypes2.default.func
};

SearchForm.defaultProps = {
  colNum: 4,
  initRow: 0,
  button: 'default',
  alignType: 'label'
};

exports.default = _compatible.Form.create({
  //表单值变化事件，回调到
  onValuesChange: function onValuesChange(props, changedValues, allValues) {
    if (typeof props.onValuesChange === 'function') {
      props.onChange(props, changedValues, allValues);
    }
  }
})(SearchForm);